diff --git a/pki/base/common/src/com/netscape/cms/authentication/CMCAuth.java b/pki/base/common/src/com/netscape/cms/authentication/CMCAuth.java
index cf57098b651f8964e1ae9dd00bec682b1e23cf41..905efc42a2538738de40227d4c4398f5d3bc64ac 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/CMCAuth.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/CMCAuth.java
@@ -451,7 +451,6 @@ public class CMCAuth implements IAuthManager, IExtendedPluginInfo,
                                     // }
 
                                     INTEGER temp = revRequest.getSerialNumber();
-                                    int temp2 = temp.intValue();
 
                                     bigIntArray[j] = temp;
                                     authToken.set(TOKEN_CERT_SERIAL, bigIntArray);
@@ -783,7 +782,7 @@ public class CMCAuth implements IAuthManager, IExtendedPluginInfo,
 
             SET dais = cmcFullReq.getDigestAlgorithmIdentifiers();
             int numDig = dais.size();
-            Hashtable digs = new Hashtable();
+            Hashtable<String, byte[]> digs = new Hashtable<String, byte[]>();
 
             //if request key is used for signing, there MUST be only one signerInfo
             //object in the signedData object.
diff --git a/pki/base/common/src/com/netscape/cms/authentication/HashAuthentication.java b/pki/base/common/src/com/netscape/cms/authentication/HashAuthentication.java
index 4aae1f15954f31f7759a36e2b9734d872e7c5fe8..57b86157efa19524c6f279daf299882945ad39b0 100644
--- a/pki/base/common/src/com/netscape/cms/authentication/HashAuthentication.java
+++ b/pki/base/common/src/com/netscape/cms/authentication/HashAuthentication.java
@@ -62,19 +62,19 @@ public class HashAuthentication implements IAuthManager, IExtendedPluginInfo {
     private String mHost;
     private long mLastLogin = 0;
     private MessageDigest mSHADigest = null;
-    private Hashtable mData = null;
+    private Hashtable<String, IAuthToken> mData = null;
     private IConfigStore mConfig;
     private String mName = null;
     private String mImplName = null;
     private ILogger mLogger = CMS.getLogger();
-    private static Vector mExtendedPluginInfo = null;
+    private static Vector<String> mExtendedPluginInfo = null;
     private HashAuthData mHosts = null;
 
     static String[] mConfigParams =
             new String[] {};
 
     static {
-        mExtendedPluginInfo = new Vector();
+        mExtendedPluginInfo = new Vector<String>();
         mExtendedPluginInfo.add(IExtendedPluginInfo.HELP_TEXT +
                 ";Authenticate the username and password provided " +
                 "by the user against an LDAP directory. Works with the " +
@@ -94,7 +94,7 @@ public class HashAuthentication implements IAuthManager, IExtendedPluginInfo {
         mName = name;
         mImplName = implName;
         mConfig = config;
-        mData = new Hashtable();
+        mData = new Hashtable<String, IAuthToken>();
         mHosts = new HashAuthData();
 
         try {
@@ -106,7 +106,7 @@ public class HashAuthentication implements IAuthManager, IExtendedPluginInfo {
     }
 
     public IAuthToken getAuthToken(String key) {
-        return (IAuthToken) mData.remove(key);
+        return mData.remove(key);
     }
 
     public void addAuthToken(String pageID, IAuthToken token) {
@@ -114,7 +114,7 @@ public class HashAuthentication implements IAuthManager, IExtendedPluginInfo {
     }
 
     public void deleteToken(String pageID) {
-        IAuthToken token = (IAuthToken) mData.remove(pageID);
+        mData.remove(pageID);
     }
 
     public HashAuthData getData() {
diff --git a/pki/base/common/src/com/netscape/cms/jobs/RenewalNotificationJob.java b/pki/base/common/src/com/netscape/cms/jobs/RenewalNotificationJob.java
index 0c6178e99afa22390efd465bb17973c09c7e8afc..8abe027c4e924a34ae10f88f72be2d8ee6f1d181 100644
--- a/pki/base/common/src/com/netscape/cms/jobs/RenewalNotificationJob.java
+++ b/pki/base/common/src/com/netscape/cms/jobs/RenewalNotificationJob.java
@@ -19,7 +19,6 @@ package com.netscape.cms.jobs;
 
 import java.io.IOException;
 import java.text.DateFormat;
-import java.util.Calendar;
 import java.util.Date;
 import java.util.Enumeration;
 import java.util.Locale;
diff --git a/pki/base/common/src/com/netscape/cms/listeners/PinRemovalListener.java b/pki/base/common/src/com/netscape/cms/listeners/PinRemovalListener.java
index c71b9c60365e84779b6bb78e227bfbf00df380a5..662e762b03a3f1629224ea6c630c81b460e102e9 100644
--- a/pki/base/common/src/com/netscape/cms/listeners/PinRemovalListener.java
+++ b/pki/base/common/src/com/netscape/cms/listeners/PinRemovalListener.java
@@ -17,8 +17,6 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.listeners;
 
-import java.util.Hashtable;
-
 import netscape.ldap.LDAPAttribute;
 import netscape.ldap.LDAPConnection;
 import netscape.ldap.LDAPEntry;
@@ -28,7 +26,6 @@ import netscape.ldap.LDAPSearchResults;
 import netscape.ldap.LDAPv2;
 
 import com.netscape.certsrv.apps.CMS;
-import com.netscape.certsrv.authority.ICertAuthority;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.base.IConfigStore;
 import com.netscape.certsrv.base.ISubsystem;
@@ -56,9 +53,7 @@ public class PinRemovalListener implements IRequestListener {
 
     private boolean mEnabled = false;
     private ILogger mLogger = CMS.getLogger();
-    private Hashtable mContentParams = new Hashtable();
 
-    private ICertAuthority mSub = null;
     private IConfigStore mConfig = null;
     private IConfigStore mLdapConfig = null;
     private RequestId mReqId = null;
diff --git a/pki/base/common/src/com/netscape/cms/listeners/RequestInQListener.java b/pki/base/common/src/com/netscape/cms/listeners/RequestInQListener.java
index e5c075208933d27aefcfd1280583269381b8e568..7ff13db54de61ce232360a327113889f7df5ca72 100644
--- a/pki/base/common/src/com/netscape/cms/listeners/RequestInQListener.java
+++ b/pki/base/common/src/com/netscape/cms/listeners/RequestInQListener.java
@@ -71,7 +71,7 @@ public class RequestInQListener implements IRequestListener {
     private String mEmailSubject = null;
     private String mFormPath = null;
     private IConfigStore mConfig = null;
-    private Hashtable mContentParams = new Hashtable();
+    private Hashtable<String, Object> mContentParams = new Hashtable<String, Object>();
     private String mId = "RequestInQListener";
     private ICertAuthority mSubsystem = null;
     private String mHttpHost = null;
diff --git a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
index db61382c57ef8f127b264162ccacb2e530a65025..d3b5d545e8c859298947c7d2acbda119095baa0c 100644
--- a/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
+++ b/pki/base/common/src/com/netscape/cms/ocsp/DefStore.java
@@ -27,7 +27,6 @@ import java.util.Hashtable;
 import java.util.Locale;
 import java.util.Vector;
 
-import netscape.security.x509.CRLNumberExtension;
 import netscape.security.x509.RevokedCertificate;
 import netscape.security.x509.X509CRLImpl;
 import netscape.security.x509.X509CertImpl;
@@ -48,6 +47,7 @@ import com.netscape.certsrv.common.Constants;
 import com.netscape.certsrv.common.NameValuePairs;
 import com.netscape.certsrv.dbs.IDBRegistry;
 import com.netscape.certsrv.dbs.IDBSSession;
+import com.netscape.certsrv.dbs.IDBSearchResults;
 import com.netscape.certsrv.dbs.IDBSubsystem;
 import com.netscape.certsrv.dbs.Modification;
 import com.netscape.certsrv.dbs.ModificationSet;
@@ -111,8 +111,6 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
     private IConfigStore mConfig = null;
     private String mId = null;
     private IDBSubsystem mDBService = null;
-    private X509CRLImpl mCRLImpl = null;
-    private CRLNumberExtension mCRLNumberExt = null;
     private int mStateCount = 0;
 
     /**
@@ -226,15 +224,12 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
      * new one is totally committed.
      */
     public void deleteOldCRLs() throws EBaseException {
-        Enumeration<Object> recs = searchCRLIssuingPointRecord(
+        Enumeration<ICRLIssuingPointRecord> recs = searchCRLIssuingPointRecord(
                 "objectclass=" +
                         CMS.getCRLIssuingPointRecordName(),
                 100);
-        X509CertImpl theCert = null;
-        ICRLIssuingPointRecord theRec = null;
-
         while (recs.hasMoreElements()) {
-            ICRLIssuingPointRecord rec = (ICRLIssuingPointRecord) recs.nextElement();
+            ICRLIssuingPointRecord rec = recs.nextElement();
             deleteOldCRLsInCA(rec.getId());
         }
     }
@@ -252,14 +247,14 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                 return; // nothing to do
             String thisUpdate = Long.toString(
                     cp.getThisUpdate().getTime());
-            Enumeration<Object> e = searchRepository(
+            Enumeration<IRepositoryRecord> e = searchRepository(
                     caName,
                     "(!" + IRepositoryRecord.ATTR_SERIALNO + "=" +
                             thisUpdate + ")");
 
             while (e != null && e.hasMoreElements()) {
-                IRepositoryRecord r = (IRepositoryRecord) e.nextElement();
-                Enumeration<Object> recs =
+                IRepositoryRecord r = e.nextElement();
+                Enumeration<ICertRecord> recs =
                         searchCertRecord(caName,
                                 r.getSerialNumber().toString(),
                                 ICertRecord.ATTR_ID + "=*");
@@ -437,14 +432,13 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                     mCacheCRLIssuingPoints.get(new String(keyhsh));
 
             if (matched == null) {
-                Enumeration<Object> recs = searchCRLIssuingPointRecord(
+                Enumeration<ICRLIssuingPointRecord> recs = searchCRLIssuingPointRecord(
                         "objectclass=" +
                                 CMS.getCRLIssuingPointRecordName(),
                         100);
 
                 while (recs.hasMoreElements()) {
-                    ICRLIssuingPointRecord rec = (ICRLIssuingPointRecord)
-                            recs.nextElement();
+                    ICRLIssuingPointRecord rec = recs.nextElement();
                     byte certdata[] = rec.getCACert();
                     X509CertImpl cert = null;
 
@@ -579,7 +573,7 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         return mDBService.getBaseDN();
     }
 
-    public Enumeration<Object> searchAllCRLIssuingPointRecord(int maxSize)
+    public Enumeration<ICRLIssuingPointRecord> searchAllCRLIssuingPointRecord(int maxSize)
             throws EBaseException {
         return searchCRLIssuingPointRecord(
                 "objectclass=" +
@@ -587,19 +581,22 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
                 maxSize);
     }
 
-    public Enumeration<Object> searchCRLIssuingPointRecord(String filter,
+    public Enumeration<ICRLIssuingPointRecord> searchCRLIssuingPointRecord(String filter,
             int maxSize)
             throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<ICRLIssuingPointRecord> v = new Vector<ICRLIssuingPointRecord>();
 
         try {
-            e = s.search(getBaseDN(), filter, maxSize);
+            IDBSearchResults sr = s.search(getBaseDN(), filter, maxSize);
+            while (sr.hasMoreElements()) {
+                v.add((ICRLIssuingPointRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
     public synchronized void modifyCRLIssuingPointRecord(String name,
@@ -685,19 +682,22 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         }
     }
 
-    public Enumeration<Object> searchRepository(String name, String filter)
+    public Enumeration<IRepositoryRecord> searchRepository(String name, String filter)
             throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<IRepositoryRecord> v = new Vector<IRepositoryRecord>();
 
         try {
-            e = s.search("cn=" + transformDN(name) + "," + getBaseDN(),
+            IDBSearchResults sr = s.search("cn=" + transformDN(name) + "," + getBaseDN(),
                         filter);
+            while (sr.hasMoreElements()) {
+                v.add((IRepositoryRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
     /**
@@ -736,20 +736,23 @@ public class DefStore implements IDefStore, IExtendedPluginInfo {
         }
     }
 
-    public Enumeration<Object> searchCertRecord(String name, String thisUpdate,
+    public Enumeration<ICertRecord> searchCertRecord(String name, String thisUpdate,
             String filter) throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<ICertRecord> v = new Vector<ICertRecord>();
 
         try {
-            e = s.search("ou=" + thisUpdate + ",cn=" +
+            IDBSearchResults sr = s.search("ou=" + thisUpdate + ",cn=" +
                         transformDN(name) + "," + getBaseDN(),
                         filter);
+            while (sr.hasMoreElements()) {
+                v.add((ICertRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
     public ICertRecord readCertRecord(String name, String thisUpdate,
diff --git a/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java b/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
index 765a7950459e634892ecd6c0fa6aa7a0c99d2c8a..697d1bb4029e9c9b302b5bc17f5e9f918ce1bdcf 100644
--- a/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
+++ b/pki/base/common/src/com/netscape/cms/ocsp/LDAPStore.java
@@ -33,6 +33,7 @@ import netscape.ldap.LDAPEntry;
 import netscape.ldap.LDAPException;
 import netscape.ldap.LDAPSearchResults;
 import netscape.ldap.LDAPv2;
+import netscape.security.x509.RevokedCertificate;
 import netscape.security.x509.X509CRLImpl;
 import netscape.security.x509.X509CertImpl;
 import netscape.security.x509.X509Key;
@@ -395,9 +396,9 @@ public class LDAPStore implements IDefStore, IExtendedPluginInfo {
         throw new EBaseException("NOT SUPPORTED");
     }
 
-    public Enumeration<Object> searchAllCRLIssuingPointRecord(int maxSize)
+    public Enumeration<ICRLIssuingPointRecord> searchAllCRLIssuingPointRecord(int maxSize)
             throws EBaseException {
-        Vector<Object> recs = new Vector<Object>();
+        Vector<ICRLIssuingPointRecord> recs = new Vector<ICRLIssuingPointRecord>();
         Enumeration<X509CertImpl> keys = mCRLs.keys();
 
         while (keys.hasMoreElements()) {
@@ -409,7 +410,7 @@ public class LDAPStore implements IDefStore, IExtendedPluginInfo {
         return recs.elements();
     }
 
-    public Enumeration searchCRLIssuingPointRecord(String filter,
+    public Enumeration<ICRLIssuingPointRecord> searchCRLIssuingPointRecord(String filter,
             int maxSize)
             throws EBaseException {
         return null;
@@ -672,11 +673,11 @@ class TempCRLIssuingPointRecord implements ICRLIssuingPointRecord {
         return null;
     }
 
-    public Hashtable getCRLCacheNoClone() {
+    public Hashtable<BigInteger, RevokedCertificate> getCRLCacheNoClone() {
         return null;
     }
 
-    public Hashtable getCRLCache() {
+    public Hashtable<BigInteger, RevokedCertificate> getCRLCache() {
         return null;
     }
 
@@ -717,25 +718,25 @@ class TempCRLIssuingPointRecord implements ICRLIssuingPointRecord {
     /**
      * Retrieves cache info of revoked certificates.
      */
-    public Hashtable getRevokedCerts() {
+    public Hashtable<BigInteger, RevokedCertificate> getRevokedCerts() {
         return mCRL.getListOfRevokedCertificates();
     }
 
     /**
      * Retrieves cache info of unrevoked certificates.
      */
-    public Hashtable getUnrevokedCerts() {
+    public Hashtable<BigInteger, RevokedCertificate> getUnrevokedCerts() {
         return null;
     }
 
     /**
      * Retrieves cache info of expired certificates.
      */
-    public Hashtable getExpiredCerts() {
+    public Hashtable<BigInteger, RevokedCertificate> getExpiredCerts() {
         return null;
     }
 
-    public Enumeration getSerializableAttrNames() {
+    public Enumeration<String> getSerializableAttrNames() {
         return null;
     }
 
@@ -750,7 +751,7 @@ class TempCRLIssuingPointRecord implements ICRLIssuingPointRecord {
 
     }
 
-    public Enumeration getElements() {
+    public Enumeration<Object> getElements() {
         return null;
     }
 }
diff --git a/pki/base/common/src/com/netscape/cms/profile/common/ProfileContext.java b/pki/base/common/src/com/netscape/cms/profile/common/ProfileContext.java
index 7a275b1e6770a25a51722abf25ed0b86d35f26c5..7d068637899f3a79f27ea4d35b20f063d96013e8 100644
--- a/pki/base/common/src/com/netscape/cms/profile/common/ProfileContext.java
+++ b/pki/base/common/src/com/netscape/cms/profile/common/ProfileContext.java
@@ -27,13 +27,13 @@ import com.netscape.certsrv.profile.IProfileContext;
  * @version $Revision$, $Date$
  */
 public class ProfileContext implements IProfileContext {
-    private Hashtable m_Attrs = new Hashtable();
+    private Hashtable<String, String> m_Attrs = new Hashtable<String, String>();
 
     public void set(String name, String value) {
         m_Attrs.put(name, value);
     }
 
     public String get(String name) {
-        return (String) m_Attrs.get(name);
+        return m_Attrs.get(name);
     }
 }
diff --git a/pki/base/common/src/com/netscape/cms/profile/common/RAEnrollProfile.java b/pki/base/common/src/com/netscape/cms/profile/common/RAEnrollProfile.java
index ed028ceeb64db9eecd25ea03e3e73ffcab88b8da..36bac1fa763fe9ec8cfac88abb248ddb7d1e18db 100644
--- a/pki/base/common/src/com/netscape/cms/profile/common/RAEnrollProfile.java
+++ b/pki/base/common/src/com/netscape/cms/profile/common/RAEnrollProfile.java
@@ -110,11 +110,11 @@ public class RAEnrollProfile extends EnrollProfile {
         }
 
         // request handling
-        Enumeration names = ra.getRequestListenerNames();
+        Enumeration<String> names = ra.getRequestListenerNames();
 
         if (names != null) {
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name = names.nextElement();
 
                 CMS.debug("CAEnrollProfile: listener " + name);
                 IRequestListener listener = ra.getRequestListener(name);
diff --git a/pki/base/common/src/com/netscape/cms/profile/input/SubjectNameInput.java b/pki/base/common/src/com/netscape/cms/profile/input/SubjectNameInput.java
index 55ede138656da9b99791c4815885df57c8c6d51e..db70da6661b6a21ab332b0111183b35d0732a370 100644
--- a/pki/base/common/src/com/netscape/cms/profile/input/SubjectNameInput.java
+++ b/pki/base/common/src/com/netscape/cms/profile/input/SubjectNameInput.java
@@ -113,8 +113,8 @@ public class SubjectNameInput extends EnrollInput implements IProfileInput {
     /**
      * Returns selected value names based on the configuration.
      */
-    public Enumeration getValueNames() {
-        Vector v = new Vector();
+    public Enumeration<String> getValueNames() {
+        Vector<String> v = new Vector<String>();
         String c_uid = getConfig(CONFIG_UID);
         if (c_uid == null || c_uid.equals("")) {
             v.addElement(VAL_UID); // default case
diff --git a/pki/base/common/src/com/netscape/cms/publish/publishers/Utils.java b/pki/base/common/src/com/netscape/cms/publish/publishers/Utils.java
index 5bd342286c4c584a7576b46a64d60d27acca557e..03561ee786b6a85a354b16ba414a96cd35757665 100644
--- a/pki/base/common/src/com/netscape/cms/publish/publishers/Utils.java
+++ b/pki/base/common/src/com/netscape/cms/publish/publishers/Utils.java
@@ -35,7 +35,7 @@ import java.util.Vector;
  */
 public class Utils {
     public static void checkHost(String hostname) throws UnknownHostException {
-        InetAddress addr = InetAddress.getByName(hostname);
+        InetAddress.getByName(hostname);
     }
 
     public static void copyStream(InputStream in, OutputStream out) throws IOException {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/CMSAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/CMSAdminServlet.java
index 41f0c248f8a1f16e6b322254bc9486606f2aabe9..b77de59c68733f9279548dcd053b000caaec2000 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/CMSAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/CMSAdminServlet.java
@@ -799,7 +799,6 @@ public final class CMSAdminServlet extends AdminServlet {
             IOException, EBaseException {
         NameValuePairs params = new NameValuePairs();
         Enumeration<ISubsystem> e = CMS.getSubsystems();
-        StringBuffer buff = new StringBuffer();
 
         while (e.hasMoreElements()) {
             String type = "";
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
index b93e6eb0b6e5786fe638728534cf1103ca562562..bfd5004a2b52f72e05c3a9ee0a9e397f32612b1c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
@@ -311,7 +311,7 @@ public class JobsAdminServlet extends AdminServlet {
                 destStore.getSubStore(scope);
 
         // Does the class exist?
-        Class newImpl = null;
+        Class<?> newImpl = null;
 
         try {
             newImpl = Class.forName(classPath);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/DisplayHtmlServlet.java b/pki/base/common/src/com/netscape/cms/servlet/base/DisplayHtmlServlet.java
index ffd602b25a47bde3f68388bef43f9d8339e0de75..54e453f3073289a2f3d1d47938f3c453eab6af3b 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/DisplayHtmlServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/DisplayHtmlServlet.java
@@ -26,7 +26,6 @@ import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
 
 import com.netscape.certsrv.apps.CMS;
-import com.netscape.certsrv.authentication.IAuthToken;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.logging.ILogger;
 import com.netscape.cms.servlet.common.CMSRequest;
@@ -63,7 +62,7 @@ public class DisplayHtmlServlet extends CMSServlet {
     public void process(CMSRequest cmsReq) throws EBaseException {
         CMS.debug("DisplayHtmlServlet about to service ");
 
-        IAuthToken authToken = authenticate(cmsReq);
+        authenticate(cmsReq);
 
         try {
             String realpath =
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java b/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
index e145ee4db54ad7f911862ddac84bc4907b1806f6..c21b5683565dc6145f9bf59a1bb71de3152d6855 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
@@ -106,9 +106,6 @@ public class GetStats extends CMSServlet {
             return;
         }
 
-        // Construct an ArgBlock
-        IArgBlock args = cmsReq.getHttpParams();
-
         CMSTemplate form = null;
         Locale[] locale = new Locale[1];
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/ProxyServlet.java b/pki/base/common/src/com/netscape/cms/servlet/base/ProxyServlet.java
index 0784945abc502943e93488803f07a3e054a9fcb9..41666ab31ee32c0ddf12f2557efbb86cd5e7aaa7 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/ProxyServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/ProxyServlet.java
@@ -59,11 +59,11 @@ public class ProxyServlet extends HttpServlet {
     private String mDestContext = null;
     private String mSrcContext = null;
     private String mAppendPathInfo = null;
-    private Vector mMatchStrings = new Vector();
+    private Vector<String> mMatchStrings = new Vector<String>();
     private String mDestServletOnNoMatch = null;
     private String mAppendPathInfoOnNoMatch = null;
-    private Map mParamMap = new HashMap();
-    private Map mParamValue = new HashMap();
+    private Map<String, String> mParamMap = new HashMap<String, String>();
+    private Map<String, String[]> mParamValue = new HashMap<String, String[]>();
 
     public ProxyServlet() {
     }
@@ -130,7 +130,7 @@ public class ProxyServlet extends HttpServlet {
         if (mMatchStrings.size() != 0) {
             boolean matched = false;
             for (int i = 0; i < mMatchStrings.size(); i++) {
-                String t = (String) mMatchStrings.elementAt(i);
+                String t = mMatchStrings.elementAt(i);
                 if (uri.indexOf(t) != -1) {
                     matched = true;
                 }
@@ -171,21 +171,22 @@ public class ProxyServlet extends HttpServlet {
 }
 
 class ProxyWrapper extends HttpServletRequestWrapper {
-    private Map mMap = null;
-    private Map mValueMap = null;
+    private Map<String, String> mMap = null;
+    private Map<String, String[]> mValueMap = null;
 
     public ProxyWrapper(HttpServletRequest req) {
         super(req);
     }
 
-    public void setParameterMapAndValue(Map m, Map v) {
+    public void setParameterMapAndValue(Map<String, String> m, Map<String, String[]> v) {
         if (m != null)
             mMap = m;
         if (v != null)
             mValueMap = v;
     }
 
-    public Map getParameterMap() {
+    @SuppressWarnings("unchecked")
+    public Map<String, String[]> getParameterMap() {
         try {
             // If we haven't specified any parameter mapping, just
             // use the regular implementation
@@ -193,15 +194,15 @@ class ProxyWrapper extends HttpServletRequestWrapper {
                 return super.getParameterMap();
             else {
                 // Make a new Map for us to put stuff in
-                Map n = new HashMap();
+                Map<String, String[]> n = new HashMap<String, String[]>();
                 // get the HTTP parameters the user supplied.
-                Map m = super.getParameterMap();
-                Set s = m.entrySet();
-                Iterator i = s.iterator();
+                Map<String, String[]> m = super.getParameterMap();
+                Set<Map.Entry<String, String[]>> s = m.entrySet();
+                Iterator<Map.Entry<String, String[]>> i = s.iterator();
                 while (i.hasNext()) {
-                    Map.Entry me = (Map.Entry) i.next();
-                    String name = (String) me.getKey();
-                    String[] values = (String[]) (me.getValue());
+                    Map.Entry<String, String[]> me = i.next();
+                    String name = me.getKey();
+                    String[] values = me.getValue();
                     String newname = null;
                     if (name != null) {
                         newname = (String) mMap.get(name);
@@ -223,14 +224,14 @@ class ProxyWrapper extends HttpServletRequestWrapper {
                 }
                 // Now, deal with static values set in the config 
                 // which weren't set in the HTTP request
-                Set s2 = mValueMap.entrySet();
-                Iterator i2 = s2.iterator();
+                Set<Map.Entry<String, String[]>> s2 = mValueMap.entrySet();
+                Iterator<Map.Entry<String, String[]>> i2 = s2.iterator();
                 // Cycle through all the static values
                 while (i2.hasNext()) {
-                    Map.Entry me2 = (Map.Entry) i2.next();
-                    String name2 = (String) me2.getKey();
+                    Map.Entry<String, String[]> me2 = i2.next();
+                    String name2 = me2.getKey();
                     if (n.get(name2) == null) {
-                        String[] values2 = (String[]) me2.getValue();
+                        String[] values2 = me2.getValue();
                         // If the parameter is not set in the map
                         // Set it now
                         n.put(name2, values2);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayHashUserEnroll.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayHashUserEnroll.java
index 9815ff6872110a6175c5dcba7b1bd6ac50a28bd9..bf582a82e62f258933d4547df5b659ee48f7221c 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayHashUserEnroll.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayHashUserEnroll.java
@@ -109,9 +109,6 @@ public class DisplayHashUserEnroll extends CMSServlet {
 
         String reqHost = httpReq.getRemoteHost();
 
-        // Construct an ArgBlock
-        IArgBlock args = cmsReq.getHttpParams();
-
         if (!(mAuthority instanceof IRegistrationAuthority)) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("ADMIN_SRVLT_ERR_GET_TEMPLATE"));
             cmsReq.setError(new ECMSGWException(
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java b/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
index 3297c585c0192609a503c29050ce13ff06f7f20d..d0dfb8f9a6649a53ec42f115d3c0ac7ec7635513 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/GetEnableStatus.java
@@ -108,9 +108,6 @@ public class GetEnableStatus extends CMSServlet {
 
         String reqHost = httpReq.getRemoteHost();
 
-        // Construct an ArgBlock
-        IArgBlock args = cmsReq.getHttpParams();
-
         if (!(mAuthority instanceof IRegistrationAuthority)) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSGW_CA_FROM_RA_NOT_IMP"));
             cmsReq.setError(new ECMSGWException(
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/ReasonToRevoke.java b/pki/base/common/src/com/netscape/cms/servlet/cert/ReasonToRevoke.java
index b8e56b3e7755e1f30e972f74dde99824eab86375..0f21e1921c5a7ff9ef796841b47720517938a3e9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/ReasonToRevoke.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/ReasonToRevoke.java
@@ -245,13 +245,13 @@ public class ReasonToRevoke extends CMSServlet {
              * revokeAll, null, totalRecordCount);
              * Enumeration e = list.getCertRecords(0, totalRecordCount - 1);
              **/
-            Enumeration e = mCertDB.searchCertificates(revokeAll,
+            Enumeration<ICertRecord> e = mCertDB.searchCertificates(revokeAll,
                     totalRecordCount, mTimeLimits);
 
             int count = 0;
 
             while (e != null && e.hasMoreElements()) {
-                ICertRecord rec = (ICertRecord) e.nextElement();
+                ICertRecord rec = e.nextElement();
 
                 if (rec == null)
                     continue;
